/**
 *  Projekt Automat do IPP a IJA, FIT VUTBR 
 *  Vytvorili: 
 *             Daniel Kubek, xkubic17
 *             
 *      
 *  Aplikace pro tvorbu determinictch konench automat v grafickm 
 *  vvojovm prosted.
 *  
 *  Duben, Kvten 2005 
 *  Posledni modifikace 5.5.2005
 */  
package xmlad;

import java.lang.*;
import java.util.ArrayList; 
import java.util.List;
import java.util.Random;
import java.awt.Color;
import java.awt.Component;
import java.awt.ComponentOrientation;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;

import java.awt.Rectangle;

import javax.swing.*;
import javax.swing.event.*;
import java.math.*;
//import elementy.Stav;

/**
 *  Tda Prechod
 *  Vlastnosti instance: from, to, goOn, seznam_bodu 
 */
public class Prechod extends Component{
       
        public static final int LINE        = 0; 
        public static final int ARROW       = 1; 
        public static final int DIAMONDS    = 2; 

	private XmladElement from, to; // Stavy z a do
	//private int fromId, toId; // ID stavu z a do
	private int x1,x2,y1,y2; // Pozice pechodu
        private int r_x,r_y; // Bod ve kterm prochz ra pechodu rodiovskm elementem
        private int s_y,s_x; // Bod ve kterm prochz ra pechodu synovskm elementem
	//private char goOn; //pres ktery znak se prechazi
	/** ukazuje na Prechod krer je prv aktivn */
	public static Prechod current;
	//public ArrayList<Bod> seznam_bodu = new ArrayList<Bod>(); //seznam bod (zalomen) pechodu
    
	private boolean nakreslen=false; // pomocn promnn k uren zda je ji pechod nakraslen 
	private int tolerance = 8; // tolerance pi klikn na pechod 
	private XmladDiagramPane canvas;

	/** Konstruktor Prechodu
	 *  Povinn parametry (Stav z, Stav kam, char On)  
	 */ 
	public Prechod(XmladElement z, XmladElement kam, int typ) 
	{	
                from = z;
		to = kam;
                x1=(z.getWidth())+z.getX();
                y1=(z.getHeight())+z.getY();
                x2=(kam.getWidth())+kam.getX();
                y2=(kam.getHeight())+kam.getY();
               this.setBounds(x1<x2?x1:x2,y1<y2?y1:y2,x1<x2?x2-x1:x1-x2,y1<y2?y2-y1:y2-y1);
        /*this.canvas = canvas;*/
        //paintComponent(this.canvas.getGraphics());
        	
		
    }
         public Prechod(int x,int y,int h,int w) 
         {       
                 from = null;
                 to = null;
                 
               //  super.setBounds();
         /*this.canvas = canvas;*/
         //paintComponent(this.canvas.getGraphics());
                 
                 
         }
  /** Nastav souadnice, odkud kam pechod vede*/
/*	public void nastavSouradnice(int x1,int y1,int x2,int y2)
	{
		this.x1=x1;
		this.x2=x2;
		this.y1=y1;
		this.y2=y2;
	}*/
        public void nastavSouradnice()
        {
        
            int b_x1,b_x2,b_y1,b_y2,b_width,b_height;
           
            b_x1=(int)(from.getX()<=to.getX()?from.getX():to.getX());
            b_y1=(int)(from.getY()<=to.getY()?from.getY():to.getY());
        
            b_width =(int)(from.getX()+from.getWidth()>to.getX()+to.getWidth()?from.getX()+from.getWidth()-(from.getX()<to.getX()?from.getX():to.getX()):to.getX()+to.getWidth()-(from.getX()<to.getX()?from.getX():to.getX()));
            b_height =(int)(from.getY()+from.getHeight()>to.getY()+to.getHeight()?from.getY()+from.getHeight()-(from.getY()<to.getY()?from.getY():to.getY()):to.getY()+to.getHeight()-(from.getY()<to.getY()?from.getY():to.getY()));
            b_x2=(int)(from.getX()+from.getWidth()>to.getX()+to.getWidth()?from.getX()+from.getWidth():to.getX()+to.getWidth());
            b_y2=(int)(from.getY()+from.getHeight()>to.getY()+to.getHeight()?from.getY()+from.getHeight():to.getY()+to.getHeight());
            
            
            
            
             
            /*System.out.println(from.getX()+" "+from.getBounds().getX()); 
            System.out.println(from.getX()+" "+from.getBounds().getX()); 
            System.out.println(this.x1+" "+this.y1+" "+this.x2+" "+this.y2); */
            //super.setBounds(x1<x2?x1:x2,y1<y2?y1:y2,x1<x2?x2-x1:x1-x2,y1<y2?y2-y1:y1-y2);
            // this.setBounds(b_x1<b_x2?b_x1:b_x2,b_y1<b_y2?b_y1:b_y2,b_x1<b_x2?b_x2-b_x1:b_x1-b_x2+1,b_y1<b_y2?b_y2-b_y1:b_y1-b_y2+1);
             //this.setBounds(b_x1<b_x2?b_x1:b_x2,b_y1<b_y2?b_y1:b_y2,b_x1<b_x2?b_x2-b_x1:b_x1-b_x2+1,b_y1<b_y2?b_y2-b_y1:b_y1-b_y2+1);
             //this.setBounds(b_x1,b_y1,b_x)
            this.setBounds(b_x1,b_y1,b_width,b_height);
        
            this.x1=(int)(from.getBounds().getCenterX()-this.getX());
            this.y1=(int)(from.getBounds().getCenterY()-this.getY());
            
            this.x2=(int)(to.getBounds().getCenterX()-this.getX());
            this.y2=(int)(to.getBounds().getCenterY()-this.getY());
            
            //nastavSouradnice((int)(from.getBounds().getCenterX()-this.getX()),(int)(from.getBounds().getCenterY()-this.getY()),(int)(to.getBounds().getCenterX()-this.getX()),(int)(to.getBounds().getCenterY()-this.getY()));
           // this.vypocitej_protnuti();
            
        }
        private void vypocitej_protnuti()
        {
        double alfa,beta,gama,delta;
        
        beta = Math.tan(1);
        delta = Math.tan(beta);
        gama = Math.tan(Math.toRadians(45));
     //   delta = Math.toDegrees(Math.tan(45));
        
        alfa = Math.toDegrees(Math.atan((this.getBounds().getWidth()/this.getBounds().getHeight())));
        r_x = (int)from.getWidth()/2;
        r_y = (int)((from.getWidth()/2)/(Math.tan(Math.toRadians(alfa))));
        
        System.out.println("alfa "+ alfa + " r_x "+r_x+" r_y "+r_y);
        System.out.println("alfa "+ alfa + " beta "+beta+" gama "+gama+" delta "+delta );
        }
        
        /** Vrt Stav, ze kterho pechod vychz */
	public XmladElement vratFrom() 
	{
		return from;
	}
	/** Vrt Stav, do kterho pechod vchz */
	public XmladElement vratTo() 
	{
		return to;
	}
	/** Nastav z jakho stavu pechod vede*/
	public void setFrom(XmladElement s)
	{
		from=s;
	}
	/** Nastav do jakho  stavu pechod vede */
  public void setTo(XmladElement s)
	{
		to=s;
	}
    
	/** Nastav podle parametru bool, zda je pechod nakreslen i nikoliv */
	public void nakreslen(boolean bool)
	{
		nakreslen = bool;
	}
	/** Vraci TRUE pokud mx,my le na sece x1,y1,x2,y2*/
	public boolean jeNaUsecce(int mx, int my, int x1, int y1, int x2, int y2) 
	{
		if (y1>y2) 
		{ /* prehozeni podle y */
			int aux = x1;
			x1 = x2;
			x2 = aux;
			aux = y1;
			y1 = y2;
			y2 = aux;
		}
		if ((y1 < my) && (my <= y2 )) 
		{ 
			int dx = (x2 - x1);
			int dy = (y2 - y1);
			double prusec_x = ((double)dx / (double)dy * (double)(my - y1)) + x1;
			if (Math.abs(prusec_x - mx) <= tolerance) return true;
		}
		return false;
	}
  
	
  /** Vykresl pechod*/
/*   public void paintComponent(Graphics g) 
	
	{
		
	    g.drawLine(x1,y1,x2,y2);                
	    g.drawRect(x1<x2?x1:x2,y1<y2?y1:y2,x1<x2?x2-x1:x1-x2,y1<y2?y2-y1:y1-y2);
	}
        */
        
        
  /*  public void draw(Graphics g) 
    {
            
        g.drawLine(x1,y1,x2,y2);                
        g.drawRect(x1<x2?x1:x2,y1<y2?y1:y2,x1<x2?x2-x1:x1-x2,y1<y2?y2-y1:y1-y2);
    }*/
    
   public void paint(Graphics g) 
    {
      /*  this.x1=((from.getWidth()/2)+from.getX());
        this.y1=(from.getHeight()/2)+from.getY();
        this.x2=(to.getWidth()/2)+to.getX();
        this.y2=(to.getHeight()/2)+to.getY();
        this.setBounds(x1<x2?x1:x2,y1<y2?y1:y2,x1<x2?x2-x1:x1-x2,y1<y2?y2-y1:y1-y2);*/
       // System.out.println("getClipBounds: " +g.getClipBounds());
        //g.drawLine(this.x1,this.y1,this.x2,this.y2);  
      //  g.drawRect(0, 0, this.getWidth()-1, this.getHeight()-1);
       // g.setColor(Color.red);
       // g.drawOval(r_x-this.getX(),r_y-this.getY(),5,5);
       // g.fillPolygon();
       // g.drawString("10", (int)this.getWidth()/2, (int)this.getHeight()/2);
        
       // g.drawLine(x1<=x2?x1:this.getWidth()+1,y1<=y2?0:this.getHeight()+1,x1<=x2?this.getWidth()-1:0,y1<=y2?this.getHeight()-1:0);
        g.drawLine(this.x1,this.y1,this.x2,this.y2);
        
        //System.out.println("TEXT "+(x1<=x2?0:this.getWidth()+1)+" "+(y1<=y2?0:this.getHeight()+1)+" "+(x1<=x2?this.getWidth()-1:0)+" "+(y1<=y2?this.getHeight()-1:0));        /*g.drawLine(0,0,getWidth(),0);*/
       /* g.drawRect(x1<x2?x1:x2,y1<y2?y1:y2,x1<x2?x2-x1:x1-x2,y1<y2?y2-y1:y1-y2);           
        *///g.drawLine(this.getX(),this.getY(),this.getX()+this.getWidth(),this.getY()+this.getWidth());           
       // g.drawRect(super.getX(),super.getY(),super.getWidth(),super.getHeight());
        /*System.out.println("draw: " +this.getX()+" "+this.getY()+" "+this.getWidth()+" "+this.getHeight());
        System.out.println("Paint: " +this.x1+" "+this.y1+" "+this.x2+" "+this.y2+" "+this.getWidth()+" "+this.getHeight());
        System.out.println("Bound: " +this.getBounds());*/
        
    }
}


