package xmlad;

import java.util.*;

/*
 *
 * StrToInt
 *
 */
public class StrToInt
{
          public static int convert(String str) throws NumberFormatException
          {
                  int multiplier = 1;
                  StringTokenizer tokenizer = new StringTokenizer(str," \t\r\n\b:;[]()+");
                  while(tokenizer.hasMoreTokens())
                  {
                                multiplier = 1;
                                String token = tokenizer.nextToken();
                                if(null == token)
                                {
                                          throw new NumberFormatException(str);
                                }
                                if(token.startsWith("-"))
                                {
                                        multiplier = -1;
                                        token = token.substring(1);
                                }
                                int point_index = token.indexOf(".");
                                if(point_index > 0)
                                {
                                        token = token.substring(0,point_index);
                                } else if(point_index == 0)
                                {
                                        return 0;
                                }
                                try
                                {
                                        if(token.startsWith("0x"))
                                        {
                                                  return multiplier * Integer.parseInt(token.substring(2), 16);
                                        }
                                        else if(token.startsWith("0") && !token.equals("0"))
                                        {
                                                  return multiplier * Integer.parseInt(token.substring(1), 8);
                                        }
                                        else
                                        {
                                                  return multiplier * Integer.parseInt(token);
                                        }
                                }
                                catch(NumberFormatException e)
                                {
                                        continue;
                                }
                  }
                  throw new NumberFormatException(str);
                }
}
