package xmlad;

import com.jgoodies.looks.FontSizeHints;
import com.jgoodies.looks.Options;
import com.jgoodies.looks.plastic.Plastic3DLookAndFeel;

import java.awt.Dimension;
import java.awt.Toolkit;

import javax.swing.JFrame;
import javax.swing.UIManager;


public class Xmlad {
    protected static final Dimension PREFERRED_SIZE =
               ((Toolkit.getDefaultToolkit().getScreenSize().width <= 1024)||
               (Toolkit.getDefaultToolkit().getScreenSize().height <= 768))
               ? new Dimension(720, 510)
               : new Dimension(1024, 768);//higher than 1024x768
                
    public Xmlad() {
        JFrame frame = new XmladGUI();
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation( ( screenSize.width - frameSize.width ) / 2, ( screenSize.height - frameSize.height ) / 2 );
        frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        frame.setSize( PREFERRED_SIZE );
        frame.setExtendedState(frame.getExtendedState()|JFrame.MAXIMIZED_BOTH);
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        try {
           /* UIManager.put(Options.USE_SYSTEM_FONTS_APP_KEY, Boolean.TRUE);
                    Options.setGlobalFontSizeHints(FontSizeHints.MIXED);
                    Options.setDefaultIconSize(new Dimension(18, 18)); */
            UIManager.setLookAndFeel("com.jgoodies.looks.plastic.PlasticXPLookAndFeel");
        } catch (Exception e) {
            e.printStackTrace();
            
        }
        new Xmlad();
    }
   
}
