  
package xmlad;

import java.lang.*;
import java.util.ArrayList; 
import java.util.List;
import java.util.Random;
import java.awt.Color;
import java.awt.Component;
import java.awt.ComponentOrientation;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;

import java.awt.Rectangle;

import javax.swing.*;
import javax.swing.event.*;
import java.math.*;


public class XmladElementEdge extends Component{
       
       

	private XmladElement from, to; // Stavy z a do
	
	private int x1,x2,y1,y2; // Pozice pechodu
      
      	
	
    
	private XmladDiagramPane canvas;

	
	public XmladElementEdge(XmladElement z, XmladElement kam) 
	{	
                from = z;
		to = kam;
                nastavSouradnice();
		
    }
  /** Nastav souadnice, odkud kam pechod vede*/
        public void nastavSouradnice()
        {
        
            int b_x1,b_x2,b_y1,b_y2,b_width,b_height;
           
            b_x1=(int)(from.getX()<=to.getX()?from.getX():to.getX());
            b_y1=(int)(from.getY()<=to.getY()?from.getY():to.getY());
        
            b_width =(int)(from.getX()+from.getWidth()>to.getX()+to.getWidth()?from.getX()+from.getWidth()-(from.getX()<to.getX()?from.getX():to.getX()):to.getX()+to.getWidth()-(from.getX()<to.getX()?from.getX():to.getX()));
            b_height =(int)(from.getY()+from.getHeight()>to.getY()+to.getHeight()?from.getY()+from.getHeight()-(from.getY()<to.getY()?from.getY():to.getY()):to.getY()+to.getHeight()-(from.getY()<to.getY()?from.getY():to.getY()));
            b_x2=(int)(from.getX()+from.getWidth()>to.getX()+to.getWidth()?from.getX()+from.getWidth():to.getX()+to.getWidth());
            b_y2=(int)(from.getY()+from.getHeight()>to.getY()+to.getHeight()?from.getY()+from.getHeight():to.getY()+to.getHeight());
            this.setBounds(b_x1,b_y1,b_width,b_height);
        
            this.x1=(int)(from.getBounds().getCenterX()-this.getX());
            this.y1=(int)(from.getBounds().getCenterY()-this.getY());
            
            this.x2=(int)(to.getBounds().getCenterX()-this.getX());
            this.y2=(int)(to.getBounds().getCenterY()-this.getY());
        }
              
        /** Vrt Stav, ze kterho pechod vychz */
	public XmladElement vratFrom() 
	{
		return from;
	}
	/** Vrt Stav, do kterho pechod vchz */
	public XmladElement vratTo() 
	{
		return to;
	}
	/** Nastav z jakho stavu pechod vede*/
	public void setFrom(XmladElement s)
	{
		from=s;
	}
	/** Nastav do jakho  stavu pechod vede */
  public void setTo(XmladElement s)
	{
		to=s;
	}
    
	
   public void paint(Graphics g) 
    {   
        g.drawLine(this.x1,this.y1,this.x2,this.y2);   
    }
}


