package xmlad;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.io.IOException;
import java.net.URL;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.text.html.HTMLDocument;
import javax.swing.text.html.HTMLEditorKit;


public class XmladHelp extends JFrame {
    private BorderLayout borderLayout1 = new BorderLayout();
    private JEditorPane htmlPane = new JEditorPane();
    private static final String separator = System.getProperty("file.separator"); 
   
    private URL helpURL;
    private JScrollPane jScrollPane1 = 
        new JScrollPane(); // = XmladHelp.class.getResource(mainURL); 
   

    public XmladHelp() {
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        this.getContentPane().setLayout(borderLayout1);
        this.setSize( new Dimension(400, 300) );
        this.setTitle( "Npovda" );
        String mainURL = "help"+separator+"index.html";
        helpURL = XmladHelp.class.getResource(mainURL);
        jScrollPane1.getViewport().add(htmlPane, null);
        this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
        htmlPane.setEditable(false);
     
        htmlPane.setDocument(new HTMLDocument());
    


        htmlPane.setEditorKit(new HTMLEditorKit());
        try {
                   if (helpURL != null) {
                       htmlPane.setPage(helpURL);
                   } else { //null url
                       htmlPane.setText("Soubor nenalezen");
                       
                   }
               } catch (IOException e) {
                   System.err.println("Attempted to read a bad URL: " + helpURL);
               }
        


    }
}
